/*
 * The MIT License
 *
 * Copyright 2013 Dra0211.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */
package kinugasa.contents.graphics;

import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

/**
 * シリアライズ可能な画像を保持するクラスです.
 * <br>
 *
 * <br>
 *
 * @version 1.0.0 - 2013/01/14_17:37:15<br>
 * @author Dra0211<br>
 */
public final class SerializableImage implements Serializable {

	private static final long serialVersionUID = 2546606715890158812L;
	/** インスタンスに設定される画像データです. */
	private transient BufferedImage image;

	/**
	 * シリアライズ可能画像を作成します.
	 *
	 * @param image 画像を指定します。<br>
	 *
	 * @throws NullPointerException imageがnullの場合に投げられます。<br>
	 */
	public SerializableImage(BufferedImage image) throws NullPointerException {
		if (image == null) {
			throw new NullPointerException("image is null");
		}
		this.image = image;
	}

	/**
	 * 画像の幅を取得します.
	 *
	 * @return 画像の幅を返します。<br>
	 */
	public int getWidth() {
		return image.getWidth();
	}

	/**
	 * 画像の高さを取得します.
	 *
	 * @return 画像の高さを返します。<br>
	 */
	public int getHeight() {
		return image.getHeight();
	}

	/**
	 * 描画可能な画像インスタンスを取得します.
	 *
	 * @return 画像インスタンスを取得します。nullである場合はありません。<br>
	 */
	public BufferedImage get() {
		return image;
	}

	/**
	 * 新しい画像を設定します.
	 *
	 * @param image シリアライズ可能にする画像を指定します。<br>
	 */
	public void set(BufferedImage image) {
		this.image = image;
	}

	/**
	 * ピクセルと画像の幅をシリアライズします.
	 *
	 * @param stream 書き込むストリームが送信されます。<br>
	 *
	 * @throws IOException ストリームが発行する例外です。<br>
	 */
	private void writeObject(ObjectOutputStream stream) throws IOException {
		stream.defaultWriteObject();
		stream.writeInt(image.getWidth());
		stream.writeObject(ImageUtil.getPixel(image));
	}

	/**
	 * ピクセルと、画像を幅をデシリアライズし、描画可能な画像を再構築します.
	 *
	 * @param stream 読み込むストリームが送信されます。<br>
	 *
	 * @throws IOException ストリームが発行する例外です。<br>
	 * @throws ClassNotFoundException ストリームが発行する例外です。<br>
	 */
	private void readObject(ObjectInputStream stream) throws IOException, ClassNotFoundException {
		stream.defaultReadObject();
		int width = stream.readInt();
		int[] pixel = (int[]) stream.readObject();
		image = ImageUtil.newImage(width, pixel.length / width);
		ImageUtil.setPixel(image, pixel);
	}
}
